/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "calcellrenderer.h"
#include<iostream>
CalCellRenderer::CalCellRenderer()
:
  Glib::ObjectBase      (typeid(CalCellRenderer)),
  Gtk::CellRendererText (),
  property_focused_ (*this, "focused", false)
{}


CalCellRenderer::~CalCellRenderer()
{}

Glib::PropertyProxy<bool> CalCellRenderer::property_focused()
{
  return property_focused_.get_proxy();
}

void CalCellRenderer::render_vfunc(const Glib::RefPtr<Gdk::Drawable>& window,
                                        Gtk::Widget& widget,
                                        const Gdk::Rectangle& r1,
                                        const Gdk::Rectangle& cell_area,
                                        const Gdk::Rectangle& r2,
                                        Gtk::CellRendererState flags)
{
    Gtk::CellRendererText::render_vfunc(window,widget,r1,cell_area,r2,flags);
    if(property_focused_) {      
      widget.get_style()->paint_focus(
		                            Glib::RefPtr<Gdk::Window>::cast_dynamic(window),
                                    Gtk::STATE_ACTIVE,
                                    cell_area,
                                    widget,
                                    "focusrect",
                                    cell_area.get_x(),
                                    cell_area.get_y(),
                                    cell_area.get_width(),
                                    cell_area.get_height());
    }
}
