/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "prefdialog.h"
#include<vector>
#include"mainwindow.h"
#include"globals.h"

PrefDialog::PrefDialog(BaseObjectType* cobject, 
                       const Glib::RefPtr<Gnome::Glade::Xml>& refGlade)
: Gtk::Window(cobject),
  m_refGlade(refGlade),
  startFromMondayRadiobutton(0),
  toolbarStyleComboBox(0),
  // new option placeholder
  colorTodayLabel(0),
  colorTodayEventBox(0),
  colorPStartLabel(0),
  colorPStartEventBox(0),
  colorPPStartLabel(0),
  colorPPStartEventBox(0),
  colorFertileLabel(0),
  colorFertileEventBox(0),
  colorPFertileLabel(0),
  colorPFertileEventBox(0),
  colorPregnancyLabel(0),
  colorPregnancyEventBox(0),
  colorBirthLabel(0),
  colorBirthEventBox(0),
  colorPBirthLabel(0),
  colorPBirthEventBox(0),
  reserveSpinbutton(0),
  badFeelStartSpinbutton(0),
  badFeelEndSpinbutton(0),
  regCycleMinSpinbutton(0),
  regCycleMaxSpinbutton(0),
  prefNotebook(0),
  prefButtonBox(0),
  prefOKButton(0)
{
    refGlade->get_widget("StartFromMondayRadiobutton", startFromMondayRadiobutton);
    refGlade->get_widget("StartFromSundayRadiobutton", startFromSundayRadiobutton);    
    refGlade->get_widget("ToolbarStyleComboBox", toolbarStyleComboBox);
  // new option placeholder  
    refGlade->get_widget("ColorTodayLabel", colorTodayLabel);
    refGlade->get_widget("ColorTodayEventBox", colorTodayEventBox);
    refGlade->get_widget("ColorPStartLabel", colorPStartLabel);
    refGlade->get_widget("ColorPStartEventBox", colorPStartEventBox);
    refGlade->get_widget("ColorPPStartLabel", colorPPStartLabel);
    refGlade->get_widget("ColorPPStartEventBox", colorPPStartEventBox);
    refGlade->get_widget("ColorFertileLabel", colorFertileLabel);
    refGlade->get_widget("ColorFertileEventBox", colorFertileEventBox);
    refGlade->get_widget("ColorPFertileLabel", colorPFertileLabel);
    refGlade->get_widget("ColorPFertileEventBox", colorPFertileEventBox);
    refGlade->get_widget("ColorPregnancyLabel", colorPregnancyLabel);
    refGlade->get_widget("ColorPregnancyEventBox", colorPregnancyEventBox);
    refGlade->get_widget("ColorBirthLabel", colorBirthLabel);
    refGlade->get_widget("ColorBirthEventBox", colorBirthEventBox);
    refGlade->get_widget("ColorPBirthLabel", colorPBirthLabel);
    refGlade->get_widget("ColorPBirthEventBox", colorPBirthEventBox);
    refGlade->get_widget("ReserveSpinbutton", reserveSpinbutton);
    refGlade->get_widget("BadFeelStartSpinbutton", badFeelStartSpinbutton);
    refGlade->get_widget("BadFeelEndSpinbutton", badFeelEndSpinbutton);
    refGlade->get_widget("RegCycleMinSpinbutton", regCycleMinSpinbutton);
    refGlade->get_widget("RegCycleMaxSpinbutton", regCycleMaxSpinbutton);
    refGlade->get_widget("PrefNotebook", prefNotebook);
    refGlade->get_widget("hbuttonbox1", prefButtonBox);
    refGlade->get_widget("OKButton", prefOKButton);

    Gtk::Button* pButton = 0;
    refGlade->get_widget("ColorTodayButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_ColorTodayButton_click));
    }
    
    pButton = 0;
    refGlade->get_widget("ColorPStartButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_ColorPStartButton_click));
    }
    
    pButton = 0;
    refGlade->get_widget("ColorPPStartButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_ColorPPStartButton_click));
    }
    
    pButton = 0;
    refGlade->get_widget("ColorFertileButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_ColorFertileButton_click));
    }
    
    pButton = 0;
    refGlade->get_widget("ColorPFertileButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_ColorPFertileButton_click));
    }

    pButton = 0;
    refGlade->get_widget("ColorPregnancyButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_ColorPregnancyButton_click));
    }

    pButton = 0;
    refGlade->get_widget("ColorBirthButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_ColorBirthButton_click));
    }

    pButton = 0;
    refGlade->get_widget("ColorPBirthButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_ColorPBirthButton_click));
    }
    
    pButton = 0;
    refGlade->get_widget("FGColorTodayButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_FGColorTodayButton_click));
    }
    
    pButton = 0;
    refGlade->get_widget("FGColorPStartButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_FGColorPStartButton_click));
    }
    
    pButton = 0;
    refGlade->get_widget("FGColorPPStartButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_FGColorPPStartButton_click));
    }
    
    pButton = 0;
    refGlade->get_widget("FGColorFertileButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_FGColorFertileButton_click));
    }
    
    pButton = 0;
    refGlade->get_widget("FGColorPFertileButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_FGColorPFertileButton_click));
    }

    pButton = 0;
    refGlade->get_widget("FGColorPregnancyButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_FGColorPregnancyButton_click));
    }

    pButton = 0;
    refGlade->get_widget("FGColorBirthButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_FGColorBirthButton_click));
    }

    pButton = 0;
    refGlade->get_widget("FGColorPBirthButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_FGColorPBirthButton_click));
    }

    if(prefOKButton)
    {
      prefOKButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_ok_click));
    }

    pButton = 0;
    refGlade->get_widget("CancelButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &Gtk::Window::hide));
    }

    pButton = 0;
    refGlade->get_widget("DefaultsButton", pButton);
    if(pButton)
    {
      pButton->signal_clicked().connect(sigc::mem_fun(*this, &PrefDialog::on_defaults_click));
    }

    calOptions = new PCalOptions();
}


PrefDialog::~PrefDialog()
{
    delete calOptions;
}

void PrefDialog::on_ok_click() 
{
    storeOptions();
    *pMainWindow->calOptions = *calOptions;
    // strore in the static variable to be accessible globally
    pMainWindow->calOptions->saveLocalOptions();
    pMainWindow->engine->changeOptions(calOptions->bufferDays,
                   calOptions->badFeelDaysBefore,
                   calOptions->badFeelDaysAfter,
                   calOptions->regularMinLength,
                   calOptions->regularMaxLength);
    pMainWindow->refreshCalendarView();
    pMainWindow->refreshLegend();
    pMainWindow->refreshToolbar();
	hide();
}

void PrefDialog::present(PCalMainWindow * main_window)
{
    pMainWindow = main_window;
    *calOptions = *main_window->calOptions;
    getOptions();
    prefNotebook->set_current_page(0);
    if(Gtk::Dialog::alternative_button_order(get_screen())) {
        prefButtonBox->reorder_child(*prefOKButton, 1);
    } else {
        prefButtonBox->reorder_child(*prefOKButton, 2);
    }
    Gtk::Window::present();
}

void PrefDialog::on_cancel_click()
{
	hide();
}

void PrefDialog::on_defaults_click()
{
    calOptions->resetToDefaults();
    getOptions();
}

void PrefDialog::select_cell_color(Gtk::Label* label, Gtk::EventBox* box, bool fg)
{
  Gtk::ColorSelectionDialog dialog;
  Gdk::Color m_Color;

  //Set the current color:
  Gtk::ColorSelection* pColorSel = dialog.get_colorsel();
  if(fg) {
    pColorSel->set_current_color(label->get_style()->get_fg(Gtk::STATE_NORMAL));
  } else {
    pColorSel->set_current_color(box->get_style()->get_bg(Gtk::STATE_NORMAL));
  }
  
  int result = dialog.run();
  
  //Handle the response:
  switch(result)
  {
    case(Gtk::RESPONSE_OK):
    {
      //Store the chosen color, and show it:
      m_Color = pColorSel->get_current_color();
      if(!fg) {
          box->modify_bg(Gtk::STATE_NORMAL, m_Color);
      } else {
          label->modify_fg(Gtk::STATE_NORMAL, m_Color);
      }
      break;
    }
    default:
    {
      break;
    }
  }
}

void PrefDialog::on_ColorTodayButton_click()
{
    select_cell_color(colorTodayLabel, colorTodayEventBox);
}

void PrefDialog::on_ColorPStartButton_click()
{
    select_cell_color(colorPStartLabel, colorPStartEventBox);
}

void PrefDialog::on_ColorPPStartButton_click()
{
    select_cell_color(colorPPStartLabel, colorPPStartEventBox);
}

void PrefDialog::on_ColorFertileButton_click()
{
    select_cell_color(colorFertileLabel, colorFertileEventBox);
}

void PrefDialog::on_ColorPFertileButton_click()
{
    select_cell_color(colorPFertileLabel, colorPFertileEventBox);
}

void PrefDialog::on_ColorPregnancyButton_click()
{
    select_cell_color(colorPregnancyLabel, colorPregnancyEventBox);
}

void PrefDialog::on_ColorBirthButton_click()
{
    select_cell_color(colorBirthLabel, colorBirthEventBox);
}

void PrefDialog::on_ColorPBirthButton_click()
{
    select_cell_color(colorPBirthLabel, colorPBirthEventBox);
}

void PrefDialog::on_FGColorTodayButton_click()
{
    select_cell_color(colorTodayLabel, colorTodayEventBox, true);
}

void PrefDialog::on_FGColorPStartButton_click()
{
    select_cell_color(colorPStartLabel, colorPStartEventBox, true);
}

void PrefDialog::on_FGColorPPStartButton_click()
{
    select_cell_color(colorPPStartLabel, colorPPStartEventBox, true);
}

void PrefDialog::on_FGColorFertileButton_click()
{
    select_cell_color(colorFertileLabel, colorFertileEventBox, true);
}

void PrefDialog::on_FGColorPFertileButton_click()
{
    select_cell_color(colorPFertileLabel, colorPFertileEventBox, true);
}

void PrefDialog::on_FGColorPregnancyButton_click()
{
    select_cell_color(colorPregnancyLabel, colorPregnancyEventBox, true);
}

void PrefDialog::on_FGColorBirthButton_click()
{
    select_cell_color(colorBirthLabel, colorBirthEventBox, true);
}

void PrefDialog::on_FGColorPBirthButton_click()
{
    select_cell_color(colorPBirthLabel, colorPBirthEventBox, true);
}

void PrefDialog::getOptions()
{
    if(calOptions->firstDay == Glib::Date::MONDAY) {
        startFromMondayRadiobutton->set_active();
    } else {
        startFromSundayRadiobutton->set_active();
    }
    if(calOptions->toolbarStyle == "Icons") {
        toolbarStyleComboBox->set_active(1);
    } else
    if(calOptions->toolbarStyle == "Text") {
        toolbarStyleComboBox->set_active(2);
    } else
    if(calOptions->toolbarStyle == "Both") {
        toolbarStyleComboBox->set_active(3);
    } else
    if(calOptions->toolbarStyle == "Both Horizontal") {
        toolbarStyleComboBox->set_active(4);
    } else {
        // System Default are default
        toolbarStyleComboBox->set_active(0);
    }
       
  // new option placeholder
    colorTodayLabel->modify_fg(Gtk::STATE_NORMAL, calOptions->todayFGColor);
    colorTodayEventBox->modify_bg(Gtk::STATE_NORMAL, calOptions->todayBGColor);
    colorPStartLabel->modify_fg(Gtk::STATE_NORMAL, calOptions->day1FGColor);
    colorPStartEventBox->modify_bg(Gtk::STATE_NORMAL, calOptions->day1BGColor);
    colorPPStartLabel->modify_fg(Gtk::STATE_NORMAL, calOptions->pday1FGColor);
    colorPPStartEventBox->modify_bg(Gtk::STATE_NORMAL, calOptions->pday1BGColor);
    colorFertileLabel->modify_fg(Gtk::STATE_NORMAL, calOptions->fertFGColor);
    colorFertileEventBox->modify_bg(Gtk::STATE_NORMAL, calOptions->fertBGColor);
    colorPFertileLabel->modify_fg(Gtk::STATE_NORMAL, calOptions->pfertFGColor);
    colorPFertileEventBox->modify_bg(Gtk::STATE_NORMAL, calOptions->pfertBGColor);
    colorPregnancyLabel->modify_fg(Gtk::STATE_NORMAL, calOptions->pregFGColor);
    colorPregnancyEventBox->modify_bg(Gtk::STATE_NORMAL, calOptions->pregBGColor);
    colorBirthLabel->modify_fg(Gtk::STATE_NORMAL, calOptions->birthFGColor);
    colorBirthEventBox->modify_bg(Gtk::STATE_NORMAL, calOptions->birthBGColor);
    colorPBirthLabel->modify_fg(Gtk::STATE_NORMAL, calOptions->pbirthFGColor);
    colorPBirthEventBox->modify_bg(Gtk::STATE_NORMAL, calOptions->pbirthBGColor);

    reserveSpinbutton->set_value(calOptions->bufferDays);
    badFeelStartSpinbutton->set_value(calOptions->badFeelDaysBefore);
    badFeelEndSpinbutton->set_value(calOptions->badFeelDaysAfter);
    regCycleMinSpinbutton->set_value(calOptions->regularMinLength);
    regCycleMaxSpinbutton->set_value(calOptions->regularMaxLength);
}

void PrefDialog::storeOptions()
{
    if(startFromMondayRadiobutton->get_active()) {
        calOptions->firstDay = Glib::Date::MONDAY;
    } else {
        calOptions->firstDay = Glib::Date::SUNDAY;
    }
    switch(toolbarStyleComboBox->get_active_row_number()) {
        case 1:calOptions->toolbarStyle = "Icons"; break;
        case 2:calOptions->toolbarStyle = "Text"; break;
        case 3:calOptions->toolbarStyle = "Both"; break;
        case 4:calOptions->toolbarStyle = "Both Horizontal"; break;
        default:calOptions->toolbarStyle = "System Default";
    }    
    // new option placeholder    
    calOptions->todayFGColor = colorTodayLabel->get_style()->get_fg(Gtk::STATE_NORMAL);
    calOptions->todayBGColor = colorTodayEventBox->get_style()->get_bg(Gtk::STATE_NORMAL);
    calOptions->day1FGColor = colorPStartLabel->get_style()->get_fg(Gtk::STATE_NORMAL);
    calOptions->day1BGColor = colorPStartEventBox->get_style()->get_bg(Gtk::STATE_NORMAL);
    calOptions->pday1FGColor = colorPPStartLabel->get_style()->get_fg(Gtk::STATE_NORMAL);
    calOptions->pday1BGColor = colorPPStartEventBox->get_style()->get_bg(Gtk::STATE_NORMAL);
    calOptions->fertFGColor = colorFertileLabel->get_style()->get_fg(Gtk::STATE_NORMAL);
    calOptions->fertBGColor = colorFertileEventBox->get_style()->get_bg(Gtk::STATE_NORMAL);
    calOptions->pfertFGColor = colorPFertileLabel->get_style()->get_fg(Gtk::STATE_NORMAL);
    calOptions->pfertBGColor = colorPFertileEventBox->get_style()->get_bg(Gtk::STATE_NORMAL);
    calOptions->pregFGColor = colorPregnancyLabel->get_style()->get_fg(Gtk::STATE_NORMAL);
    calOptions->pregBGColor = colorPregnancyEventBox->get_style()->get_bg(Gtk::STATE_NORMAL);
    calOptions->birthFGColor = colorBirthLabel->get_style()->get_fg(Gtk::STATE_NORMAL);
    calOptions->birthBGColor = colorBirthEventBox->get_style()->get_bg(Gtk::STATE_NORMAL);
    calOptions->pbirthFGColor = colorPBirthLabel->get_style()->get_fg(Gtk::STATE_NORMAL);
    calOptions->pbirthBGColor = colorPBirthEventBox->get_style()->get_bg(Gtk::STATE_NORMAL);
    calOptions->bufferDays = reserveSpinbutton->get_value_as_int();
    calOptions->badFeelDaysBefore = badFeelStartSpinbutton->get_value_as_int();
    calOptions->badFeelDaysAfter = badFeelEndSpinbutton->get_value_as_int();
    calOptions->regularMinLength = regCycleMinSpinbutton->get_value_as_int();
    calOptions->regularMaxLength = regCycleMaxSpinbutton->get_value_as_int();
}
